=== debian/control ===
Source: ros-kinetic-nerian-stereo
Section: misc
Priority: optional
Maintainer: Konstantin Schauwecker <konstantin.schauwecker@nerian.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-kinetic-catkin, ros-kinetic-cv-bridge, ros-kinetic-dynamic-reconfigure, ros-kinetic-message-generation, ros-kinetic-nodelet, ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-stereo-msgs, ros-kinetic-tf2, ros-kinetic-tf2-ros
Homepage: http://wiki.ros.org/nerian_stereo
Standards-Version: 3.9.2

Package: ros-kinetic-nerian-stereo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, curl, libboost-all-dev, libcurl4-openssl-dev, ros-kinetic-cv-bridge, ros-kinetic-dynamic-reconfigure, ros-kinetic-message-runtime, ros-kinetic-nodelet, ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-stereo-msgs, ros-kinetic-tf2, ros-kinetic-tf2-ros
Description: Driver node for Scarlet and SceneScan stereo vision sensors by Nerian Vision GmbH
